// Code generated by ent, DO NOT EDIT.

package ent

import (
	"context"
	"database/sql/driver"
	"fmt"
	"math"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/in-toto/archivista/ent/dsse"
	"github.com/in-toto/archivista/ent/predicate"
	"github.com/in-toto/archivista/ent/signature"
	"github.com/in-toto/archivista/ent/timestamp"
)

// SignatureQuery is the builder for querying Signature entities.
type SignatureQuery struct {
	config
	ctx                 *QueryContext
	order               []signature.OrderOption
	inters              []Interceptor
	predicates          []predicate.Signature
	withDsse            *DsseQuery
	withTimestamps      *TimestampQuery
	withFKs             bool
	modifiers           []func(*sql.Selector)
	loadTotal           []func(context.Context, []*Signature) error
	withNamedTimestamps map[string]*TimestampQuery
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Where adds a new predicate for the SignatureQuery builder.
func (sq *SignatureQuery) Where(ps ...predicate.Signature) *SignatureQuery {
	sq.predicates = append(sq.predicates, ps...)
	return sq
}

// Limit the number of records to be returned by this query.
func (sq *SignatureQuery) Limit(limit int) *SignatureQuery {
	sq.ctx.Limit = &limit
	return sq
}

// Offset to start from.
func (sq *SignatureQuery) Offset(offset int) *SignatureQuery {
	sq.ctx.Offset = &offset
	return sq
}

// Unique configures the query builder to filter duplicate records on query.
// By default, unique is set to true, and can be disabled using this method.
func (sq *SignatureQuery) Unique(unique bool) *SignatureQuery {
	sq.ctx.Unique = &unique
	return sq
}

// Order specifies how the records should be ordered.
func (sq *SignatureQuery) Order(o ...signature.OrderOption) *SignatureQuery {
	sq.order = append(sq.order, o...)
	return sq
}

// QueryDsse chains the current query on the "dsse" edge.
func (sq *SignatureQuery) QueryDsse() *DsseQuery {
	query := (&DsseClient{config: sq.config}).Query()
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := sq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := sq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(signature.Table, signature.FieldID, selector),
			sqlgraph.To(dsse.Table, dsse.FieldID),
			sqlgraph.Edge(sqlgraph.M2O, true, signature.DsseTable, signature.DsseColumn),
		)
		fromU = sqlgraph.SetNeighbors(sq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// QueryTimestamps chains the current query on the "timestamps" edge.
func (sq *SignatureQuery) QueryTimestamps() *TimestampQuery {
	query := (&TimestampClient{config: sq.config}).Query()
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := sq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := sq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(signature.Table, signature.FieldID, selector),
			sqlgraph.To(timestamp.Table, timestamp.FieldID),
			sqlgraph.Edge(sqlgraph.O2M, false, signature.TimestampsTable, signature.TimestampsColumn),
		)
		fromU = sqlgraph.SetNeighbors(sq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// First returns the first Signature entity from the query.
// Returns a *NotFoundError when no Signature was found.
func (sq *SignatureQuery) First(ctx context.Context) (*Signature, error) {
	nodes, err := sq.Limit(1).All(setContextOp(ctx, sq.ctx, "First"))
	if err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nil, &NotFoundError{signature.Label}
	}
	return nodes[0], nil
}

// FirstX is like First, but panics if an error occurs.
func (sq *SignatureQuery) FirstX(ctx context.Context) *Signature {
	node, err := sq.First(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return node
}

// FirstID returns the first Signature ID from the query.
// Returns a *NotFoundError when no Signature ID was found.
func (sq *SignatureQuery) FirstID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = sq.Limit(1).IDs(setContextOp(ctx, sq.ctx, "FirstID")); err != nil {
		return
	}
	if len(ids) == 0 {
		err = &NotFoundError{signature.Label}
		return
	}
	return ids[0], nil
}

// FirstIDX is like FirstID, but panics if an error occurs.
func (sq *SignatureQuery) FirstIDX(ctx context.Context) int {
	id, err := sq.FirstID(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return id
}

// Only returns a single Signature entity found by the query, ensuring it only returns one.
// Returns a *NotSingularError when more than one Signature entity is found.
// Returns a *NotFoundError when no Signature entities are found.
func (sq *SignatureQuery) Only(ctx context.Context) (*Signature, error) {
	nodes, err := sq.Limit(2).All(setContextOp(ctx, sq.ctx, "Only"))
	if err != nil {
		return nil, err
	}
	switch len(nodes) {
	case 1:
		return nodes[0], nil
	case 0:
		return nil, &NotFoundError{signature.Label}
	default:
		return nil, &NotSingularError{signature.Label}
	}
}

// OnlyX is like Only, but panics if an error occurs.
func (sq *SignatureQuery) OnlyX(ctx context.Context) *Signature {
	node, err := sq.Only(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// OnlyID is like Only, but returns the only Signature ID in the query.
// Returns a *NotSingularError when more than one Signature ID is found.
// Returns a *NotFoundError when no entities are found.
func (sq *SignatureQuery) OnlyID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = sq.Limit(2).IDs(setContextOp(ctx, sq.ctx, "OnlyID")); err != nil {
		return
	}
	switch len(ids) {
	case 1:
		id = ids[0]
	case 0:
		err = &NotFoundError{signature.Label}
	default:
		err = &NotSingularError{signature.Label}
	}
	return
}

// OnlyIDX is like OnlyID, but panics if an error occurs.
func (sq *SignatureQuery) OnlyIDX(ctx context.Context) int {
	id, err := sq.OnlyID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// All executes the query and returns a list of Signatures.
func (sq *SignatureQuery) All(ctx context.Context) ([]*Signature, error) {
	ctx = setContextOp(ctx, sq.ctx, "All")
	if err := sq.prepareQuery(ctx); err != nil {
		return nil, err
	}
	qr := querierAll[[]*Signature, *SignatureQuery]()
	return withInterceptors[[]*Signature](ctx, sq, qr, sq.inters)
}

// AllX is like All, but panics if an error occurs.
func (sq *SignatureQuery) AllX(ctx context.Context) []*Signature {
	nodes, err := sq.All(ctx)
	if err != nil {
		panic(err)
	}
	return nodes
}

// IDs executes the query and returns a list of Signature IDs.
func (sq *SignatureQuery) IDs(ctx context.Context) (ids []int, err error) {
	if sq.ctx.Unique == nil && sq.path != nil {
		sq.Unique(true)
	}
	ctx = setContextOp(ctx, sq.ctx, "IDs")
	if err = sq.Select(signature.FieldID).Scan(ctx, &ids); err != nil {
		return nil, err
	}
	return ids, nil
}

// IDsX is like IDs, but panics if an error occurs.
func (sq *SignatureQuery) IDsX(ctx context.Context) []int {
	ids, err := sq.IDs(ctx)
	if err != nil {
		panic(err)
	}
	return ids
}

// Count returns the count of the given query.
func (sq *SignatureQuery) Count(ctx context.Context) (int, error) {
	ctx = setContextOp(ctx, sq.ctx, "Count")
	if err := sq.prepareQuery(ctx); err != nil {
		return 0, err
	}
	return withInterceptors[int](ctx, sq, querierCount[*SignatureQuery](), sq.inters)
}

// CountX is like Count, but panics if an error occurs.
func (sq *SignatureQuery) CountX(ctx context.Context) int {
	count, err := sq.Count(ctx)
	if err != nil {
		panic(err)
	}
	return count
}

// Exist returns true if the query has elements in the graph.
func (sq *SignatureQuery) Exist(ctx context.Context) (bool, error) {
	ctx = setContextOp(ctx, sq.ctx, "Exist")
	switch _, err := sq.FirstID(ctx); {
	case IsNotFound(err):
		return false, nil
	case err != nil:
		return false, fmt.Errorf("ent: check existence: %w", err)
	default:
		return true, nil
	}
}

// ExistX is like Exist, but panics if an error occurs.
func (sq *SignatureQuery) ExistX(ctx context.Context) bool {
	exist, err := sq.Exist(ctx)
	if err != nil {
		panic(err)
	}
	return exist
}

// Clone returns a duplicate of the SignatureQuery builder, including all associated steps. It can be
// used to prepare common query builders and use them differently after the clone is made.
func (sq *SignatureQuery) Clone() *SignatureQuery {
	if sq == nil {
		return nil
	}
	return &SignatureQuery{
		config:         sq.config,
		ctx:            sq.ctx.Clone(),
		order:          append([]signature.OrderOption{}, sq.order...),
		inters:         append([]Interceptor{}, sq.inters...),
		predicates:     append([]predicate.Signature{}, sq.predicates...),
		withDsse:       sq.withDsse.Clone(),
		withTimestamps: sq.withTimestamps.Clone(),
		// clone intermediate query.
		sql:  sq.sql.Clone(),
		path: sq.path,
	}
}

// WithDsse tells the query-builder to eager-load the nodes that are connected to
// the "dsse" edge. The optional arguments are used to configure the query builder of the edge.
func (sq *SignatureQuery) WithDsse(opts ...func(*DsseQuery)) *SignatureQuery {
	query := (&DsseClient{config: sq.config}).Query()
	for _, opt := range opts {
		opt(query)
	}
	sq.withDsse = query
	return sq
}

// WithTimestamps tells the query-builder to eager-load the nodes that are connected to
// the "timestamps" edge. The optional arguments are used to configure the query builder of the edge.
func (sq *SignatureQuery) WithTimestamps(opts ...func(*TimestampQuery)) *SignatureQuery {
	query := (&TimestampClient{config: sq.config}).Query()
	for _, opt := range opts {
		opt(query)
	}
	sq.withTimestamps = query
	return sq
}

// GroupBy is used to group vertices by one or more fields/columns.
// It is often used with aggregate functions, like: count, max, mean, min, sum.
//
// Example:
//
//	var v []struct {
//		KeyID string `json:"key_id,omitempty"`
//		Count int `json:"count,omitempty"`
//	}
//
//	client.Signature.Query().
//		GroupBy(signature.FieldKeyID).
//		Aggregate(ent.Count()).
//		Scan(ctx, &v)
func (sq *SignatureQuery) GroupBy(field string, fields ...string) *SignatureGroupBy {
	sq.ctx.Fields = append([]string{field}, fields...)
	grbuild := &SignatureGroupBy{build: sq}
	grbuild.flds = &sq.ctx.Fields
	grbuild.label = signature.Label
	grbuild.scan = grbuild.Scan
	return grbuild
}

// Select allows the selection one or more fields/columns for the given query,
// instead of selecting all fields in the entity.
//
// Example:
//
//	var v []struct {
//		KeyID string `json:"key_id,omitempty"`
//	}
//
//	client.Signature.Query().
//		Select(signature.FieldKeyID).
//		Scan(ctx, &v)
func (sq *SignatureQuery) Select(fields ...string) *SignatureSelect {
	sq.ctx.Fields = append(sq.ctx.Fields, fields...)
	sbuild := &SignatureSelect{SignatureQuery: sq}
	sbuild.label = signature.Label
	sbuild.flds, sbuild.scan = &sq.ctx.Fields, sbuild.Scan
	return sbuild
}

// Aggregate returns a SignatureSelect configured with the given aggregations.
func (sq *SignatureQuery) Aggregate(fns ...AggregateFunc) *SignatureSelect {
	return sq.Select().Aggregate(fns...)
}

func (sq *SignatureQuery) prepareQuery(ctx context.Context) error {
	for _, inter := range sq.inters {
		if inter == nil {
			return fmt.Errorf("ent: uninitialized interceptor (forgotten import ent/runtime?)")
		}
		if trv, ok := inter.(Traverser); ok {
			if err := trv.Traverse(ctx, sq); err != nil {
				return err
			}
		}
	}
	for _, f := range sq.ctx.Fields {
		if !signature.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
		}
	}
	if sq.path != nil {
		prev, err := sq.path(ctx)
		if err != nil {
			return err
		}
		sq.sql = prev
	}
	return nil
}

func (sq *SignatureQuery) sqlAll(ctx context.Context, hooks ...queryHook) ([]*Signature, error) {
	var (
		nodes       = []*Signature{}
		withFKs     = sq.withFKs
		_spec       = sq.querySpec()
		loadedTypes = [2]bool{
			sq.withDsse != nil,
			sq.withTimestamps != nil,
		}
	)
	if sq.withDsse != nil {
		withFKs = true
	}
	if withFKs {
		_spec.Node.Columns = append(_spec.Node.Columns, signature.ForeignKeys...)
	}
	_spec.ScanValues = func(columns []string) ([]any, error) {
		return (*Signature).scanValues(nil, columns)
	}
	_spec.Assign = func(columns []string, values []any) error {
		node := &Signature{config: sq.config}
		nodes = append(nodes, node)
		node.Edges.loadedTypes = loadedTypes
		return node.assignValues(columns, values)
	}
	if len(sq.modifiers) > 0 {
		_spec.Modifiers = sq.modifiers
	}
	for i := range hooks {
		hooks[i](ctx, _spec)
	}
	if err := sqlgraph.QueryNodes(ctx, sq.driver, _spec); err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nodes, nil
	}
	if query := sq.withDsse; query != nil {
		if err := sq.loadDsse(ctx, query, nodes, nil,
			func(n *Signature, e *Dsse) { n.Edges.Dsse = e }); err != nil {
			return nil, err
		}
	}
	if query := sq.withTimestamps; query != nil {
		if err := sq.loadTimestamps(ctx, query, nodes,
			func(n *Signature) { n.Edges.Timestamps = []*Timestamp{} },
			func(n *Signature, e *Timestamp) { n.Edges.Timestamps = append(n.Edges.Timestamps, e) }); err != nil {
			return nil, err
		}
	}
	for name, query := range sq.withNamedTimestamps {
		if err := sq.loadTimestamps(ctx, query, nodes,
			func(n *Signature) { n.appendNamedTimestamps(name) },
			func(n *Signature, e *Timestamp) { n.appendNamedTimestamps(name, e) }); err != nil {
			return nil, err
		}
	}
	for i := range sq.loadTotal {
		if err := sq.loadTotal[i](ctx, nodes); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

func (sq *SignatureQuery) loadDsse(ctx context.Context, query *DsseQuery, nodes []*Signature, init func(*Signature), assign func(*Signature, *Dsse)) error {
	ids := make([]int, 0, len(nodes))
	nodeids := make(map[int][]*Signature)
	for i := range nodes {
		if nodes[i].dsse_signatures == nil {
			continue
		}
		fk := *nodes[i].dsse_signatures
		if _, ok := nodeids[fk]; !ok {
			ids = append(ids, fk)
		}
		nodeids[fk] = append(nodeids[fk], nodes[i])
	}
	if len(ids) == 0 {
		return nil
	}
	query.Where(dsse.IDIn(ids...))
	neighbors, err := query.All(ctx)
	if err != nil {
		return err
	}
	for _, n := range neighbors {
		nodes, ok := nodeids[n.ID]
		if !ok {
			return fmt.Errorf(`unexpected foreign-key "dsse_signatures" returned %v`, n.ID)
		}
		for i := range nodes {
			assign(nodes[i], n)
		}
	}
	return nil
}
func (sq *SignatureQuery) loadTimestamps(ctx context.Context, query *TimestampQuery, nodes []*Signature, init func(*Signature), assign func(*Signature, *Timestamp)) error {
	fks := make([]driver.Value, 0, len(nodes))
	nodeids := make(map[int]*Signature)
	for i := range nodes {
		fks = append(fks, nodes[i].ID)
		nodeids[nodes[i].ID] = nodes[i]
		if init != nil {
			init(nodes[i])
		}
	}
	query.withFKs = true
	query.Where(predicate.Timestamp(func(s *sql.Selector) {
		s.Where(sql.InValues(s.C(signature.TimestampsColumn), fks...))
	}))
	neighbors, err := query.All(ctx)
	if err != nil {
		return err
	}
	for _, n := range neighbors {
		fk := n.signature_timestamps
		if fk == nil {
			return fmt.Errorf(`foreign-key "signature_timestamps" is nil for node %v`, n.ID)
		}
		node, ok := nodeids[*fk]
		if !ok {
			return fmt.Errorf(`unexpected referenced foreign-key "signature_timestamps" returned %v for node %v`, *fk, n.ID)
		}
		assign(node, n)
	}
	return nil
}

func (sq *SignatureQuery) sqlCount(ctx context.Context) (int, error) {
	_spec := sq.querySpec()
	if len(sq.modifiers) > 0 {
		_spec.Modifiers = sq.modifiers
	}
	_spec.Node.Columns = sq.ctx.Fields
	if len(sq.ctx.Fields) > 0 {
		_spec.Unique = sq.ctx.Unique != nil && *sq.ctx.Unique
	}
	return sqlgraph.CountNodes(ctx, sq.driver, _spec)
}

func (sq *SignatureQuery) querySpec() *sqlgraph.QuerySpec {
	_spec := sqlgraph.NewQuerySpec(signature.Table, signature.Columns, sqlgraph.NewFieldSpec(signature.FieldID, field.TypeInt))
	_spec.From = sq.sql
	if unique := sq.ctx.Unique; unique != nil {
		_spec.Unique = *unique
	} else if sq.path != nil {
		_spec.Unique = true
	}
	if fields := sq.ctx.Fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, signature.FieldID)
		for i := range fields {
			if fields[i] != signature.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, fields[i])
			}
		}
	}
	if ps := sq.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if limit := sq.ctx.Limit; limit != nil {
		_spec.Limit = *limit
	}
	if offset := sq.ctx.Offset; offset != nil {
		_spec.Offset = *offset
	}
	if ps := sq.order; len(ps) > 0 {
		_spec.Order = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return _spec
}

func (sq *SignatureQuery) sqlQuery(ctx context.Context) *sql.Selector {
	builder := sql.Dialect(sq.driver.Dialect())
	t1 := builder.Table(signature.Table)
	columns := sq.ctx.Fields
	if len(columns) == 0 {
		columns = signature.Columns
	}
	selector := builder.Select(t1.Columns(columns...)...).From(t1)
	if sq.sql != nil {
		selector = sq.sql
		selector.Select(selector.Columns(columns...)...)
	}
	if sq.ctx.Unique != nil && *sq.ctx.Unique {
		selector.Distinct()
	}
	for _, p := range sq.predicates {
		p(selector)
	}
	for _, p := range sq.order {
		p(selector)
	}
	if offset := sq.ctx.Offset; offset != nil {
		// limit is mandatory for offset clause. We start
		// with default value, and override it below if needed.
		selector.Offset(*offset).Limit(math.MaxInt32)
	}
	if limit := sq.ctx.Limit; limit != nil {
		selector.Limit(*limit)
	}
	return selector
}

// WithNamedTimestamps tells the query-builder to eager-load the nodes that are connected to the "timestamps"
// edge with the given name. The optional arguments are used to configure the query builder of the edge.
func (sq *SignatureQuery) WithNamedTimestamps(name string, opts ...func(*TimestampQuery)) *SignatureQuery {
	query := (&TimestampClient{config: sq.config}).Query()
	for _, opt := range opts {
		opt(query)
	}
	if sq.withNamedTimestamps == nil {
		sq.withNamedTimestamps = make(map[string]*TimestampQuery)
	}
	sq.withNamedTimestamps[name] = query
	return sq
}

// SignatureGroupBy is the group-by builder for Signature entities.
type SignatureGroupBy struct {
	selector
	build *SignatureQuery
}

// Aggregate adds the given aggregation functions to the group-by query.
func (sgb *SignatureGroupBy) Aggregate(fns ...AggregateFunc) *SignatureGroupBy {
	sgb.fns = append(sgb.fns, fns...)
	return sgb
}

// Scan applies the selector query and scans the result into the given value.
func (sgb *SignatureGroupBy) Scan(ctx context.Context, v any) error {
	ctx = setContextOp(ctx, sgb.build.ctx, "GroupBy")
	if err := sgb.build.prepareQuery(ctx); err != nil {
		return err
	}
	return scanWithInterceptors[*SignatureQuery, *SignatureGroupBy](ctx, sgb.build, sgb, sgb.build.inters, v)
}

func (sgb *SignatureGroupBy) sqlScan(ctx context.Context, root *SignatureQuery, v any) error {
	selector := root.sqlQuery(ctx).Select()
	aggregation := make([]string, 0, len(sgb.fns))
	for _, fn := range sgb.fns {
		aggregation = append(aggregation, fn(selector))
	}
	if len(selector.SelectedColumns()) == 0 {
		columns := make([]string, 0, len(*sgb.flds)+len(sgb.fns))
		for _, f := range *sgb.flds {
			columns = append(columns, selector.C(f))
		}
		columns = append(columns, aggregation...)
		selector.Select(columns...)
	}
	selector.GroupBy(selector.Columns(*sgb.flds...)...)
	if err := selector.Err(); err != nil {
		return err
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := sgb.build.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

// SignatureSelect is the builder for selecting fields of Signature entities.
type SignatureSelect struct {
	*SignatureQuery
	selector
}

// Aggregate adds the given aggregation functions to the selector query.
func (ss *SignatureSelect) Aggregate(fns ...AggregateFunc) *SignatureSelect {
	ss.fns = append(ss.fns, fns...)
	return ss
}

// Scan applies the selector query and scans the result into the given value.
func (ss *SignatureSelect) Scan(ctx context.Context, v any) error {
	ctx = setContextOp(ctx, ss.ctx, "Select")
	if err := ss.prepareQuery(ctx); err != nil {
		return err
	}
	return scanWithInterceptors[*SignatureQuery, *SignatureSelect](ctx, ss.SignatureQuery, ss, ss.inters, v)
}

func (ss *SignatureSelect) sqlScan(ctx context.Context, root *SignatureQuery, v any) error {
	selector := root.sqlQuery(ctx)
	aggregation := make([]string, 0, len(ss.fns))
	for _, fn := range ss.fns {
		aggregation = append(aggregation, fn(selector))
	}
	switch n := len(*ss.selector.flds); {
	case n == 0 && len(aggregation) > 0:
		selector.Select(aggregation...)
	case n != 0 && len(aggregation) > 0:
		selector.AppendSelect(aggregation...)
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := ss.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}
